Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 128)
@@ -746,85 +865,89 @@
 
 #define _ALLOC3_VALACK_IN(    sig,type, x1, x2, x3)                     \
-  {                                                                     \
-    sig = new SC_IN (Tcontrol_t) *** [x1];                              \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_IN (Tcontrol_t) ** [x2];                     \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            sig [it1][it2] = new SC_IN (Tcontrol_t) * [x3];             \
-            for (uint32_t it3=0; it3<x3; it3++)                         \
-              {                                                         \
-                sig [it1][it2][it3] = interface[it1][it2][it3]->set_signal_valack_in (type); \
-              }                                                         \
-          }                                                             \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_IN (Tcontrol_t) *** [x1];                            \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_IN (Tcontrol_t) ** [x2];                   \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              sig [it1][it2] = new SC_IN (Tcontrol_t) * [x3];           \
+              for (uint32_t it3=0; it3<x3; it3++)                       \
+                {                                                       \
+                  sig [it1][it2][it3] = interface[it1][it2][it3]->set_signal_valack_in (type); \
+                }                                                       \
+            }                                                           \
+        }                                                               \
+    } while (0)
 
 #define _ALLOC3_VALACK_OUT(    sig,type, x1, x2, x3)                    \
-  {                                                                     \
-    sig = new SC_OUT (Tcontrol_t) *** [x1];                             \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_OUT (Tcontrol_t) ** [x2];                    \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            sig [it1][it2] = new SC_OUT (Tcontrol_t) * [x3];            \
-            for (uint32_t it3=0; it3<x3; it3++)                         \
-              {                                                         \
-                sig [it1][it2][it3] = interface[it1][it2][it3]->set_signal_valack_out (type); \
-              }                                                         \
-          }                                                             \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_OUT (Tcontrol_t) *** [x1];                           \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_OUT (Tcontrol_t) ** [x2];                  \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              sig [it1][it2] = new SC_OUT (Tcontrol_t) * [x3];          \
+              for (uint32_t it3=0; it3<x3; it3++)                       \
+                {                                                       \
+                  sig [it1][it2][it3] = interface[it1][it2][it3]->set_signal_valack_out (type); \
+                }                                                       \
+            }                                                           \
+        }                                                               \
+    } while (0)
 
 
 #define _ALLOC3_SIGNAL_IN( sig, name, type, size, x1, x2,x3)            \
-  {                                                                     \
-    sig = new SC_IN (type) *** [x1];                                    \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_IN (type) ** [x2];                           \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            sig [it1][it2] = new SC_IN (type) * [x3];                   \
-            for (uint32_t it3=0; it3<x3; it3++)                         \
-              {                                                         \
-                if (size > 0)                                           \
-                  {                                                     \
-                    sig [it1][it2][it3] = interface[it1][it2][it3]->set_signal_in <type> (name, size); \
-                  }                                                     \
-                else                                                    \
-                  {                                                     \
-                    PRINT_SIZE_NUL(_component,interface[it1][it2][it3],name); \
-                  }                                                     \
-              }                                                         \
-          }                                                             \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_IN (type) *** [x1];                                  \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_IN (type) ** [x2];                         \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              sig [it1][it2] = new SC_IN (type) * [x3];                 \
+              for (uint32_t it3=0; it3<x3; it3++)                       \
+                {                                                       \
+                  if (size > 0)                                         \
+                    {                                                   \
+                      sig [it1][it2][it3] = interface[it1][it2][it3]->set_signal_in <type> (name, size); \
+                    }                                                   \
+                  else                                                  \
+                    {                                                   \
+                      PRINT_SIZE_NUL(_component,interface[it1][it2][it3],name); \
+                    }                                                   \
+                }                                                       \
+            }                                                           \
+        }                                                               \
+    } while (0)
 
 #define _ALLOC3_SIGNAL_OUT( sig, name, type, size, x1, x2,x3)           \
-  {                                                                     \
-    sig = new SC_OUT (type) *** [x1];                                   \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_OUT (type) ** [x2];                          \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            sig [it1][it2] = new SC_OUT (type) * [x3];                  \
-            for (uint32_t it3=0; it3<x3; it3++)                         \
-              {                                                         \
-                if (size > 0)                                           \
-                  {                                                     \
-                    sig [it1][it2][it3] = interface[it1][it2][it3]->set_signal_out <type> (name, size); \
-                  }                                                     \
-                else                                                    \
-                  {                                                     \
-                    PRINT_SIZE_NUL(_component,interface[it1][it2][it3],name); \
-                  }                                                     \
-              }                                                         \
-          }                                                             \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_OUT (type) *** [x1];                                 \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_OUT (type) ** [x2];                        \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              sig [it1][it2] = new SC_OUT (type) * [x3];                \
+              for (uint32_t it3=0; it3<x3; it3++)                       \
+                {                                                       \
+                  if (size > 0)                                         \
+                    {                                                   \
+                      sig [it1][it2][it3] = interface[it1][it2][it3]->set_signal_out <type> (name, size); \
+                    }                                                   \
+                  else                                                  \
+                    {                                                   \
+                      PRINT_SIZE_NUL(_component,interface[it1][it2][it3],name); \
+                    }                                                   \
+                }                                                       \
+            }                                                           \
+        }                                                               \
+    } while (0)
 
 // #define ALLOC3_VAL_ACK_IN( sig, name, type      ) _ALLOC3_VAL_ACK_IN( sig, name, type      , iterator_1, iterator_2, iterator_3) 
@@ -836,124 +959,138 @@
 
 #define DELETE3_SIGNAL(sig, x1, x2, x3, size)                           \
-  {                                                                     \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            for (uint32_t it3=0; it3<x3; it3++)                         \
-              {                                                         \
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              for (uint32_t it3=0; it3<x3; it3++)                       \
+                {                                                       \
+                  if (size > 0)                                         \
+                    {                                                   \
+                      delete sig[it1][it2][it3];                        \
+                    }                                                   \
+                }                                                       \
+              delete [] sig[it1][it2];                                  \
+            }                                                           \
+          delete [] sig[it1];                                           \
+        }                                                               \
+      delete [] sig;                                                    \
+    } while (0)
+
+#define ALLOC3_FOREIGN_SIGNAL_IN( sig, interface, name, type, size, x1, x2,x3)     \
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_IN (type) *** [x1];                                  \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_IN (type) ** [x2];                         \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              sig [it1][it2] = new SC_IN (type) * [x3];                 \
+              for (uint32_t it3=0; it3<x3; it3++)                       \
                 if (size > 0)                                           \
                   {                                                     \
-                    delete sig[it1][it2][it3];                          \
+                    std::string str = (toString("in")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(it1)+"_"+toString(it2)+"_"+toString(it3)+"_"+toString(name)); \
+                    sig [it1][it2][it3] = new SC_IN (type) (str.c_str()); \
+                  }                                                     \
+            }                                                           \
+        }                                                               \
+    } while (0)
+
+#define ALLOC3_FOREIGN_SIGNAL_OUT( sig, interface, name, type, size, x1, x2,x3)    \
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_OUT (type) *** [x1];                                 \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_OUT (type) ** [x2];                        \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              sig [it1][it2] = new SC_OUT (type) * [x3];                \
+              for (uint32_t it3=0; it3<x3; it3++)                       \
+                if (size > 0)                                           \
+                  {                                                     \
+                    std::string str = (toString("out")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(it1)+"_"+toString(it2)+"_"+toString(it3)+"_"+toString(name)); \
+                    sig [it1][it2][it3] = new SC_OUT(type) (str.c_str()); \
+                  }                                                     \
+            }                                                           \
+        }                                                               \
+    } while (0)
+
+#define DELETE3_FOREIGN_SIGNAL( sig, size,x1,x2,x3)            \
+  do                                                           \
+    {                                                          \
+      DELETE3_SIGNAL(sig,x1,x2,x3,size);                       \
+    } while (0)
+
+#define ALLOC3_SC_SIGNAL( sig, name, type, x1, x2, x3)                  \
+  do                                                                    \
+    {                                                                   \
+      sig = new sc_signal<type> *** [x1];                               \
+      {                                                                 \
+        std::string separator="_";                                      \
+        std::string str;                                                \
+        for (uint32_t it1=0; it1<x1; it1++)                             \
+          {                                                             \
+            sig [it1] = new sc_signal<type> ** [x2];                    \
+            for (uint32_t it2=0; it2<x2; it2++)                         \
+              {                                                         \
+                sig [it1][it2] = new sc_signal<type> * [x3];            \
+                for (uint32_t it3=0; it3<x3; it3++)                     \
+                  {                                                     \
+                    str = name+separator+toString(it1)+separator+toString(it2)+separator+toString(it3); \
+                    sig [it1][it2][it3] = new sc_signal<type> (str.c_str()); \
+                    PRINT_SIGNAL_ADDRESS(str.c_str(),sig[it1][it2][it3]); \
                   }                                                     \
               }                                                         \
-            delete [] sig[it1][it2];                                    \
-          }                                                             \
-        delete [] sig[it1];                                             \
-      }                                                                 \
-    delete [] sig;                                                      \
-  }
-
-#define ALLOC3_FOREIGN_SIGNAL_IN( sig, interface, name, type, size, x1, x2,x3)     \
-  {                                                                     \
-    sig = new SC_IN (type) *** [x1];                                    \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_IN (type) ** [x2];                           \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            sig [it1][it2] = new SC_IN (type) * [x3];                   \
-            for (uint32_t it3=0; it3<x3; it3++)                         \
-              if (size > 0)                                             \
-                {                                                       \
-                  std::string str = (toString("in")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(it1)+"_"+toString(it2)+"_"+toString(it3)+"_"+toString(name)); \
-                  sig [it1][it2][it3] = new SC_IN (type) (str.c_str()); \
-                }                                                       \
           }                                                             \
       }                                                                 \
-  }
-
-#define ALLOC3_FOREIGN_SIGNAL_OUT( sig, interface, name, type, size, x1, x2,x3)    \
-  {                                                                     \
-    sig = new SC_OUT (type) *** [x1];                                   \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_OUT (type) ** [x2];                          \
+    } while (0)
+
+#define INSTANCE3_SC_SIGNAL(component, sig, x1, x2, x3)                 \
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
         for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            sig [it1][it2] = new SC_OUT (type) * [x3];                  \
-            for (uint32_t it3=0; it3<x3; it3++)                         \
-              if (size > 0)                                             \
-                {                                                       \
-                  std::string str = (toString("out")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(it1)+"_"+toString(it2)+"_"+toString(it3)+"_"+toString(name)); \
-                  sig [it1][it2][it3] = new SC_OUT(type) (str.c_str()); \
-                }                                                       \
-          }                                                             \
-      }                                                                 \
-  }
-
-#define DELETE3_FOREIGN_SIGNAL( sig, size,x1,x2,x3)            \
-  {                                                            \
-    DELETE3_SIGNAL(sig,x1,x2,x3,size);                         \
-  }
-
-#define ALLOC3_SC_SIGNAL( sig, name, type, x1, x2, x3)                  \
-  sig = new sc_signal<type> *** [x1];                                   \
-  {                                                                     \
-    std::string separator="_";                                          \
-    std::string str;                                                    \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-         sig [it1] = new sc_signal<type> ** [x2];                       \
-         for (uint32_t it2=0; it2<x2; it2++)                            \
-           {                                                            \
-              sig [it1][it2] = new sc_signal<type> * [x3];              \
+          for (uint32_t it3=0; it3<x3; it3++)                           \
+            {                                                           \
+              TEST_SIGNAL(component->sig  [it1][it2][it3]->name(),component->sig  [it1][it2][it3]); \
+              TEST_SIGNAL(sig             [it1][it2][it3]->name(),sig             [it1][it2][it3]); \
+              (*(component->sig[it1][it2][it3])) (*(sig[it1][it2][it3])); \
+            }                                                           \
+    } while (0)
+
+#define _INSTANCE3_SC_SIGNAL(component, sig1, sig2, x1, x2, x3)         \
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        for (uint32_t it2=0; it2<x2; it2++)                             \
+          for (uint32_t it3=0; it3<x3; it3++)                           \
+            {                                                           \
+              TEST_SIGNAL(component->sig1 [it1][it2][it3]->name(),component->sig1 [it1][it2][it3]); \
+              TEST_SIGNAL(sig2            [it1][it2][it3]->name(),sig2            [it1][it2][it3]); \
+              (*(component->sig1[it1][it2][it3])) (*(sig2[it1][it2][it3])); \
+            }                                                           \
+    } while (0)
+
+#define DELETE3_SC_SIGNAL(sig,x1,x2,x3)                                 \
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
               for (uint32_t it3=0; it3<x3; it3++)                       \
                 {                                                       \
-                  str = name+separator+toString(it1)+separator+toString(it2)+separator+toString(it3); \
-                  sig [it1][it2][it3] = new sc_signal<type> (str.c_str()); \
-                  PRINT_SIGNAL_ADDRESS(str.c_str(),sig[it1][it2][it3]); \
+                  PRINT_SIGNAL_ADDRESS("",sig[it1][it2][it3]);          \
+                  delete sig[it1][it2][it3];                            \
                 }                                                       \
-           }                                                            \
-      }                                                                 \
-  }
-
-#define INSTANCE3_SC_SIGNAL(component, sig, x1, x2, x3)                 \
-  for (uint32_t it1=0; it1<x1; it1++)                                   \
-    for (uint32_t it2=0; it2<x2; it2++)                                 \
-      for (uint32_t it3=0; it3<x3; it3++)                               \
-        {                                                               \
-          TEST_SIGNAL(component->sig  [it1][it2][it3]->name(),component->sig  [it1][it2][it3]); \
-          TEST_SIGNAL(sig             [it1][it2][it3]->name(),sig             [it1][it2][it3]); \
-          (*(component->sig[it1][it2][it3])) (*(sig[it1][it2][it3]));   \
-        }
-
-#define _INSTANCE3_SC_SIGNAL(component, sig1, sig2, x1, x2, x3)         \
-  for (uint32_t it1=0; it1<x1; it1++)                                   \
-    for (uint32_t it2=0; it2<x2; it2++)                                 \
-      for (uint32_t it3=0; it3<x3; it3++)                               \
-        {                                                               \
-          TEST_SIGNAL(component->sig1 [it1][it2][it3]->name(),component->sig1 [it1][it2][it3]); \
-          TEST_SIGNAL(sig2            [it1][it2][it3]->name(),sig2            [it1][it2][it3]); \
-          (*(component->sig1[it1][it2][it3])) (*(sig2[it1][it2][it3])); \
-        }
-
-#define DELETE3_SC_SIGNAL(sig,x1,x2,x3)                                 \
-  {                                                                     \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            for (uint32_t it3=0; it3<x3; it3++)                         \
-              {                                                         \
-                PRINT_SIGNAL_ADDRESS("",sig[it1][it2][it3]);            \
-                delete sig[it1][it2][it3];                              \
-              }                                                         \
-            delete [] sig[it1][it2];                                    \
-          }                                                             \
-        delete [] sig[it1];                                             \
-      }                                                                 \
-    delete [] sig;                                                      \
-  }
+              delete [] sig[it1][it2];                                  \
+            }                                                           \
+          delete [] sig[it1];                                           \
+        }                                                               \
+      delete [] sig;                                                    \
+    } while (0)
 
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Types.h	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Types.h	(revision 128)
@@ -16,13 +16,13 @@
 
   // ***** general
+  typedef uint32_t           Tcounter_t; // universal counter
+  typedef uint32_t           Tptr_t;     // universal pointer
   typedef uint32_t           Tinstruction_t;
   typedef bool               Tcontrol_t;
   typedef uint8_t            Texception_t;
   typedef uint8_t            Tcontext_t;
-  typedef uint16_t           Tpacket_t;
+  typedef Tptr_t             Tpacket_t;
   typedef uint8_t            Toperation_t;
   typedef uint8_t            Ttype_t;
-  typedef uint32_t           Tcounter_t; // universal counter
-  typedef uint32_t           Tptr_t;     // universal pointer
   typedef uint32_t           Tspr_t;
   typedef uint16_t           Tspr_address_t;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h	(revision 128)
@@ -10,8 +10,8 @@
 #define MORPHEO_MAJOR_VERSION "0"
 #define MORPHEO_MINOR_VERSION "2"
-#define MORPHEO_REVISION      "127"
+#define MORPHEO_REVISION      "128"
 #define MORPHEO_CODENAME      "Castor"
 
-#define MORPHEO_DATE_DAY      "17"  
+#define MORPHEO_DATE_DAY      "26"  
 #define MORPHEO_DATE_MONTH    "06"
 #define MORPHEO_DATE_YEAR     "2009" 
